<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/helastic.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>helastic.c</h1><a href="helastic_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2007 Ahmet Kaya</span>
<a name="l00005"></a>00005 <span class="comment">    Copyright (C) 2005-2010 Werner Scholz</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00008"></a>00008 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00011"></a>00011 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00012"></a>00012 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00013"></a>00013 <span class="comment">    (at your option) any later version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00016"></a>00016 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00017"></a>00017 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00018"></a>00018 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00019"></a>00019 <span class="comment"></span>
<a name="l00020"></a>00020 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00021"></a>00021 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00022"></a>00022 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00023"></a>00023 <span class="comment">*/</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: helastic.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00026"></a>00026 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">static</span> <span class="keywordtype">int</span>       doinit=1;
<a name="l00031"></a>00031 <span class="keyword">static</span> <span class="keywordtype">int</span>       fieldon=0;
<a name="l00032"></a>00032 <span class="keyword">static</span> PetscReal *rval;
<a name="l00033"></a>00033 
<a name="l00034"></a><a class="code" href="helastic_8c.html#a457b69d54035f68c1d79c43f2ca1fe0a">00034</a> <span class="preprocessor">#define NPE 6</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="keyword">static</span> PetscReal *propdat;
<a name="l00036"></a>00036 <span class="keyword">static</span> Vec       VHelastic;
<a name="l00037"></a>00037 
<a name="l00038"></a><a class="code" href="helastic_8c.html#af12c767230bdb7467dd25210d5fefe50">00038</a> <span class="keywordtype">int</span> <a class="code" href="helastic_8c.html#af12c767230bdb7467dd25210d5fefe50">ReadProp</a>(<span class="keywordtype">int</span> n_prop)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   PetscTruth   flg;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="keywordtype">int</span> rank,size;
<a name="l00045"></a>00045   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00046"></a>00046   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keywordtype">char</span> str[256];
<a name="l00049"></a>00049   ierr = PetscOptionsGetString(PETSC_NULL,<span class="stringliteral">&quot;-helastic_propfile&quot;</span>,str,256,&amp;flg);CHKERRQ(ierr);
<a name="l00050"></a>00050   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00051"></a>00051     SETERRQ1(PETSC_ERR_ARG_INCOMP,<span class="stringliteral">&quot;Problem with option -helastic_propfile %s\n&quot;</span>,str);
<a name="l00052"></a>00052   }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   ierr = PetscMalloc(n_prop*<a class="code" href="helastic_8c.html#a457b69d54035f68c1d79c43f2ca1fe0a">NPE</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;propdat);CHKERRQ(ierr);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="keywordflow">if</span> (!rank) {
<a name="l00057"></a>00057     FILE *fd;
<a name="l00058"></a>00058     ierr = PetscFOpen(PETSC_COMM_WORLD,str,<span class="stringliteral">&quot;r&quot;</span>,&amp;fd);CHKERRQ(ierr);
<a name="l00059"></a>00059     <span class="keywordflow">if</span> (!fd) {
<a name="l00060"></a>00060       SETERRQ1(PETSC_ERR_FILE_OPEN,<span class="stringliteral">&quot;Cannot open %s\n&quot;</span>,str);
<a name="l00061"></a>00061     }
<a name="l00062"></a>00062     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Opening file %s\n&quot;</span>,str);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;n_prop; i++) {
<a name="l00065"></a>00065       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="helastic_8c.html#a457b69d54035f68c1d79c43f2ca1fe0a">NPE</a>; j++) {
<a name="l00066"></a>00066         <span class="keywordtype">int</span> k;
<a name="l00067"></a>00067 <span class="preprocessor">#ifdef PETSC_USE_SINGLE</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span>        k=fscanf(fd,<span class="stringliteral">&quot;%f&quot;</span>,propdat+NPE*i+j);
<a name="l00069"></a>00069 <span class="preprocessor">#else</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>        k=fscanf(fd,<span class="stringliteral">&quot;%lf&quot;</span>,propdat+NPE*i+j);
<a name="l00071"></a>00071 <span class="preprocessor">#endif</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (k!=1) {
<a name="l00073"></a>00073           SETERRQ2(PETSC_ERR_FILE_UNEXPECTED,<span class="stringliteral">&quot;Data in %s corrupt: %i!\n&quot;</span>,str,j);
<a name="l00074"></a>00074         }
<a name="l00075"></a>00075       }
<a name="l00076"></a>00076       <span class="comment">/* read remainder of this line */</span>
<a name="l00077"></a>00077       fgets(str,256,fd);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079       PetscPrintf(MPI_COMM_WORLD,<span class="stringliteral">&quot;----- property: %i -----\n&quot;</span>,i);
<a name="l00080"></a>00080       PetscPrintf(MPI_COMM_WORLD,
<a name="l00081"></a>00081         <span class="stringliteral">&quot;texture:    %g\n&quot;</span>
<a name="l00082"></a>00082         <span class="stringliteral">&quot;lambda100:  %g\n&quot;</span>
<a name="l00083"></a>00083         <span class="stringliteral">&quot;lambda111:  %g\n&quot;</span>
<a name="l00084"></a>00084         <span class="stringliteral">&quot;sigmaX:     %g\n&quot;</span>
<a name="l00085"></a>00085         <span class="stringliteral">&quot;sigmaY:     %g\n&quot;</span>
<a name="l00086"></a>00086         <span class="stringliteral">&quot;sigmaZ:     %g\n&quot;</span>,
<a name="l00087"></a>00087         propdat[NPE*i+0],
<a name="l00088"></a>00088         propdat[NPE*i+1],
<a name="l00089"></a>00089         propdat[NPE*i+2],
<a name="l00090"></a>00090         propdat[NPE*i+3],
<a name="l00091"></a>00091         propdat[NPE*i+4],
<a name="l00092"></a>00092         propdat[NPE*i+5]
<a name="l00093"></a>00093       );
<a name="l00094"></a>00094       assert(NPE==6);
<a name="l00095"></a>00095     }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097     ierr = PetscFClose(PETSC_COMM_WORLD,fd);CHKERRQ(ierr);
<a name="l00098"></a>00098   }
<a name="l00099"></a>00099   ierr = MPI_Bcast(propdat,<a class="code" href="helastic_8c.html#a457b69d54035f68c1d79c43f2ca1fe0a">NPE</a>*n_prop,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00102"></a>00102 }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a><a class="code" href="helastic_8c.html#a396340125882d5038a4dbdadc4468699">00105</a> <span class="keywordtype">int</span> <a class="code" href="helastic_8c.html#a396340125882d5038a4dbdadc4468699">Helastic_Init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00106"></a>00106 {
<a name="l00107"></a>00107   PetscTruth flg;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   ierr = PetscOptionsHasName(PETSC_NULL,<span class="stringliteral">&quot;-helastic_propfile&quot;</span>,&amp;flg);CHKERRQ(ierr);
<a name="l00112"></a>00112   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00113"></a>00113     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00114"></a>00114       <span class="stringliteral">&quot;Option -helastic_propfile not found, using default value: %i (field off)\n&quot;</span>,
<a name="l00115"></a>00115       fieldon
<a name="l00116"></a>00116     );
<a name="l00117"></a>00117   }
<a name="l00118"></a>00118   <span class="keywordflow">else</span> {
<a name="l00119"></a>00119     fieldon=1;
<a name="l00120"></a>00120   }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00123"></a>00123     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Helastic off\n&quot;</span>);
<a name="l00124"></a>00124     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00125"></a>00125   }
<a name="l00126"></a>00126   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Helastic on\n&quot;</span>);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="comment">/* read material properties from file */</span>
<a name="l00129"></a>00129   ierr = <a class="code" href="helastic_8c.html#af12c767230bdb7467dd25210d5fefe50">ReadProp</a>(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>);CHKERRQ(ierr);
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;VHelastic);CHKERRQ(ierr);
<a name="l00132"></a>00132   ierr = VecZeroEntries(VHelastic);CHKERRQ(ierr);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">/* create arrays of random numbers for random texture */</span>
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;rval);CHKERRQ(ierr);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   PetscRandom r;
<a name="l00140"></a>00140   ierr = PetscRandomCreate(PETSC_COMM_WORLD,&amp;r);CHKERRQ(ierr);
<a name="l00141"></a>00141   ierr = PetscRandomSetFromOptions(r);CHKERRQ(ierr);
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;i++) {
<a name="l00144"></a>00144     PetscReal  value1,value2,value3,value4;
<a name="l00145"></a>00145     PetscReal  ran_num1,ran_num2,ran_num3;
<a name="l00146"></a>00146     PetscReal  ww;
<a name="l00147"></a>00147     PetscReal  xx1,xx2,xx3,xx4;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149     <span class="keywordflow">do</span> {
<a name="l00150"></a>00150       PetscRandomGetValue(r,&amp;value1);
<a name="l00151"></a>00151       PetscRandomGetValue(r,&amp;value2);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153       xx1 = 2.0*value1-1.0;
<a name="l00154"></a>00154       xx2 = 2.0*value2-1.0;
<a name="l00155"></a>00155       ww = xx1*xx1+xx2*xx2;
<a name="l00156"></a>00156     } <span class="keywordflow">while</span> (ww &gt;= 1.0);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158     ww=sqrt((-2.0*log(ww))/ww);
<a name="l00159"></a>00159     ran_num1=xx1*ww;
<a name="l00160"></a>00160     ran_num2=xx2*ww;
<a name="l00161"></a>00161 
<a name="l00162"></a>00162     <span class="keywordflow">do</span> {
<a name="l00163"></a>00163       PetscRandomGetValue(r,&amp;value3);
<a name="l00164"></a>00164       PetscRandomGetValue(r,&amp;value4);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166       xx3 = 2.0*value3-1.0;
<a name="l00167"></a>00167       xx4 = 2.0*value4-1.0;
<a name="l00168"></a>00168       ww = xx3*xx3+xx4*xx4;
<a name="l00169"></a>00169     } <span class="keywordflow">while</span> (ww &gt;= 1.0);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     ww=sqrt((-2.0*log(ww))/ww);
<a name="l00172"></a>00172     ran_num3 = xx3*ww;
<a name="l00173"></a>00173 
<a name="l00174"></a>00174     rval[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+0]=(ran_num1+4.0)/(8.0);
<a name="l00175"></a>00175     rval[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+1]=(ran_num2+4.0)/(8.0);
<a name="l00176"></a>00176     rval[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i+2]=(ran_num3+4.0)/(8.0);
<a name="l00177"></a>00177   }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   PetscRandomDestroy(r);
<a name="l00180"></a>00180   <span class="comment">/* end of create random number */</span>
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00183"></a>00183 }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a><a class="code" href="helastic_8c.html#a97e3d5671797656fb91afa5e61778e74">00186</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a97e3d5671797656fb91afa5e61778e74">Helastic</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VHtotsum)
<a name="l00187"></a>00187 {
<a name="l00188"></a>00188   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="keywordflow">if</span> (doinit) {
<a name="l00191"></a>00191     ierr = <a class="code" href="helastic_8c.html#a396340125882d5038a4dbdadc4468699">Helastic_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00192"></a>00192     doinit=0;
<a name="l00193"></a>00193   }
<a name="l00194"></a>00194   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00195"></a>00195     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00196"></a>00196   }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   PetscReal *ta_Helastic,*ta_M;
<a name="l00199"></a>00199   ierr = VecGetArray(VHelastic,&amp;ta_Helastic);CHKERRQ(ierr);
<a name="l00200"></a>00200   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);CHKERRQ(ierr);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <span class="comment">/* TODO: for nodes at interfaces, the assignment is &quot;at will&quot;</span>
<a name="l00203"></a>00203 <span class="comment">     not any more: higher Ms wins</span>
<a name="l00204"></a>00204 <span class="comment">  */</span>
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; j++) {
<a name="l00207"></a>00207     <span class="keywordtype">int</span> celltexture;
<a name="l00208"></a>00208     PetscReal xA,xB,xC;
<a name="l00209"></a>00209 
<a name="l00210"></a>00210     <span class="keywordflow">if</span> (propdat[<a class="code" href="helastic_8c.html#a457b69d54035f68c1d79c43f2ca1fe0a">NPE</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+0]&lt;=0.0) <span class="keywordflow">continue</span>;
<a name="l00211"></a>00211 
<a name="l00212"></a>00212     <span class="comment">/* FIXME: safer to use round or rint?? */</span>
<a name="l00213"></a>00213     celltexture=(int)propdat[<a class="code" href="helastic_8c.html#a457b69d54035f68c1d79c43f2ca1fe0a">NPE</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+0];
<a name="l00214"></a>00214     switch (celltexture) {
<a name="l00215"></a>00215       <span class="keywordflow">case</span> 1:
<a name="l00216"></a>00216         xA=0.0;
<a name="l00217"></a>00217         xB=0.0;
<a name="l00218"></a>00218         xC=0.0;
<a name="l00219"></a>00219       <span class="keywordflow">break</span>;
<a name="l00220"></a>00220       <span class="keywordflow">case</span> 2:
<a name="l00221"></a>00221         xA=0.0;
<a name="l00222"></a>00222         xB=rval[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0]*2.0*PETSC_PI;
<a name="l00223"></a>00223         xC=rval[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1]*2.0*PETSC_PI;
<a name="l00224"></a>00224       <span class="keywordflow">break</span>;
<a name="l00225"></a>00225       <span class="keywordflow">case</span> 3:
<a name="l00226"></a>00226         xA=PETSC_PI/2.0;
<a name="l00227"></a>00227         xB=3.0*PETSC_PI/4.0;
<a name="l00228"></a>00228         xC=0.0;
<a name="l00229"></a>00229       <span class="keywordflow">break</span>;
<a name="l00230"></a>00230       <span class="keywordflow">case</span> 4:
<a name="l00231"></a>00231         xA=PETSC_PI/2.0;
<a name="l00232"></a>00232         xB=3.0*PETSC_PI/4.0;
<a name="l00233"></a>00233         xC=rval[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0]*2.0*PETSC_PI;
<a name="l00234"></a>00234       <span class="keywordflow">break</span>;
<a name="l00235"></a>00235       <span class="keywordflow">case</span> 5:
<a name="l00236"></a>00236         xA=PETSC_PI/2.0;
<a name="l00237"></a>00237         xB=asin(sqrt(2.0/3.0));
<a name="l00238"></a>00238         xC=PETSC_PI;
<a name="l00239"></a>00239       <span class="keywordflow">break</span>;
<a name="l00240"></a>00240       <span class="keywordflow">case</span> 6:
<a name="l00241"></a>00241         xA=asin(sqrt(2.0/3.0));
<a name="l00242"></a>00242         xB=3*PETSC_PI/4.0;
<a name="l00243"></a>00243         xC=rval[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0]*2.0*PETSC_PI;
<a name="l00244"></a>00244       <span class="keywordflow">break</span>;
<a name="l00245"></a>00245       <span class="keywordflow">case</span> 7:
<a name="l00246"></a>00246         xA=rval[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0]*PETSC_PI;
<a name="l00247"></a>00247         xB=rval[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1]*2.0*PETSC_PI;
<a name="l00248"></a>00248         xC=rval[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2]*2.0*PETSC_PI;
<a name="l00249"></a>00249       <span class="keywordflow">break</span>;
<a name="l00250"></a>00250       <span class="keywordflow">default</span>:
<a name="l00251"></a>00251         SETERRQ1(PETSC_ERR_ARG_INCOMP,
<a name="l00252"></a>00252           <span class="stringliteral">&quot;Unknown value for texture: %i\n&quot;</span>,
<a name="l00253"></a>00253           celltexture
<a name="l00254"></a>00254         );
<a name="l00255"></a>00255       <span class="keywordflow">break</span>;
<a name="l00256"></a>00256     }
<a name="l00257"></a>00257 
<a name="l00258"></a>00258     <span class="comment">/* Find the matrix elements from angles */</span>
<a name="l00259"></a>00259     PetscReal c1,c2,c3;
<a name="l00260"></a>00260     c1=cos(xA);
<a name="l00261"></a>00261     c2=cos(xB);
<a name="l00262"></a>00262     c3=cos(xC);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264     PetscReal s1,s2,s3;
<a name="l00265"></a>00265     s1=sin(xA);
<a name="l00266"></a>00266     s2=sin(xB);
<a name="l00267"></a>00267     s3=sin(xC);
<a name="l00268"></a>00268 
<a name="l00269"></a>00269     <span class="comment">/* matrix A^-1 */</span>
<a name="l00270"></a>00270     PetscReal a11,a12,a13,a21,a22,a23,a31,a32,a33;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272     a11= c2*c3-c1*s2*s3;
<a name="l00273"></a>00273     a21=-c2*s3-c1*s2*c3;
<a name="l00274"></a>00274     a31=s1*s2;
<a name="l00275"></a>00275     a12= s2*c3+c1*c2*s3;
<a name="l00276"></a>00276     a22=-s2*s3+c1*c2*c3;
<a name="l00277"></a>00277     a32=-s1*c2;
<a name="l00278"></a>00278     a13=s1*s3;
<a name="l00279"></a>00279     a23=s1*c3;
<a name="l00280"></a>00280     a33=c1;
<a name="l00281"></a>00281 
<a name="l00282"></a>00282     <span class="comment">/* below operations are for finding inverse Matrix */</span>
<a name="l00283"></a>00283 
<a name="l00284"></a>00284     PetscReal detA;
<a name="l00285"></a>00285     detA=a11*a22*a33+a13*a21*a32+a12*a23*a31-a11*a23*a32-a13*a22*a31-a12*a21*a33;
<a name="l00286"></a>00286 
<a name="l00287"></a>00287     <span class="comment">/* matrix A */</span>
<a name="l00288"></a>00288     PetscReal b11,b12,b13,b21,b22,b23,b31,b32,b33;
<a name="l00289"></a>00289     b11 = (a22*a33 - a23*a32)/detA;
<a name="l00290"></a>00290     b12 = (a23*a31 - a21*a33)/detA;
<a name="l00291"></a>00291     b13 = (a21*a32 - a22*a31)/detA;
<a name="l00292"></a>00292     b21 = (a13*a32 - a12*a33)/detA;
<a name="l00293"></a>00293     b22 = (a11*a33 - a13*a31)/detA;
<a name="l00294"></a>00294     b23 = (a12*a31 - a11*a32)/detA;
<a name="l00295"></a>00295     b31 = (a12*a23 - a13*a22)/detA;
<a name="l00296"></a>00296     b32 = (a13*a21 - a11*a23)/detA;
<a name="l00297"></a>00297     b33 = (a11*a22 - a12*a21)/detA;
<a name="l00298"></a>00298 
<a name="l00299"></a>00299     <span class="comment">/* get components of M */</span>
<a name="l00300"></a>00300 
<a name="l00301"></a>00301     PetscReal mx,my,mz;
<a name="l00302"></a>00302     mx=ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0];
<a name="l00303"></a>00303     my=ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1];
<a name="l00304"></a>00304     mz=ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2];
<a name="l00305"></a>00305 
<a name="l00306"></a>00306     PetscReal mxp,myp,mzp;
<a name="l00307"></a>00307     mxp=b11*mx+b21*my+b31*mz;
<a name="l00308"></a>00308     myp=b12*mx+b22*my+b32*mz;
<a name="l00309"></a>00309     mzp=b13*mx+b23*my+b33*mz;
<a name="l00310"></a>00310 
<a name="l00311"></a>00311     PetscReal lam100,lam111;
<a name="l00312"></a>00312     lam100=propdat[<a class="code" href="helastic_8c.html#a457b69d54035f68c1d79c43f2ca1fe0a">NPE</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+1];
<a name="l00313"></a>00313     lam111=propdat[<a class="code" href="helastic_8c.html#a457b69d54035f68c1d79c43f2ca1fe0a">NPE</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+2];
<a name="l00314"></a>00314 
<a name="l00315"></a>00315     PetscReal sigx,sigy,sigz;
<a name="l00316"></a>00316     sigx=propdat[<a class="code" href="helastic_8c.html#a457b69d54035f68c1d79c43f2ca1fe0a">NPE</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+3];
<a name="l00317"></a>00317     sigy=propdat[<a class="code" href="helastic_8c.html#a457b69d54035f68c1d79c43f2ca1fe0a">NPE</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+4];
<a name="l00318"></a>00318     sigz=propdat[<a class="code" href="helastic_8c.html#a457b69d54035f68c1d79c43f2ca1fe0a">NPE</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+5];
<a name="l00319"></a>00319 
<a name="l00320"></a>00320     <span class="comment">/* direction cosines of Z stress in xtal coor. sys. */</span>
<a name="l00321"></a>00321 <span class="comment">/*</span>
<a name="l00322"></a>00322 <span class="comment">    PetscReal norm;</span>
<a name="l00323"></a>00323 <span class="comment">    norm=sqrt(sigx*sigx+sigy*sigy+sigz*sigz);</span>
<a name="l00324"></a>00324 <span class="comment"></span>
<a name="l00325"></a>00325 <span class="comment">    PetscReal gamma1g,gamma2g,gamma3g;</span>
<a name="l00326"></a>00326 <span class="comment">    gamma1g=sigx/norm;</span>
<a name="l00327"></a>00327 <span class="comment">    gamma2g=sigy/norm;</span>
<a name="l00328"></a>00328 <span class="comment">    gamma3g=sigz/norm;</span>
<a name="l00329"></a>00329 <span class="comment"></span>
<a name="l00330"></a>00330 <span class="comment">    gamma1=b11*gamma1g+b21*gamma2g+b31*gamma3g;</span>
<a name="l00331"></a>00331 <span class="comment">    gamma2=b12*gamma1g+b22*gamma2g+b32*gamma3g;</span>
<a name="l00332"></a>00332 <span class="comment">    gamma3=b13*gamma1g+b23*gamma2g+b33*gamma3g;</span>
<a name="l00333"></a>00333 <span class="comment">*/</span>
<a name="l00334"></a>00334 
<a name="l00335"></a>00335     PetscReal msat;
<a name="l00336"></a>00336     msat=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+4];
<a name="l00337"></a>00337 
<a name="l00338"></a>00338     PetscReal gamma1,gamma2,gamma3;
<a name="l00339"></a>00339     PetscReal elasHkXp,elasHkYp,elasHkZp;
<a name="l00340"></a>00340 
<a name="l00341"></a>00341     gamma1=b31;
<a name="l00342"></a>00342     gamma2=b32;
<a name="l00343"></a>00343     gamma3=b33;
<a name="l00344"></a>00344     elasHkXp =  3.0/2.0*lam100*sigz/(msat)*(2.0*mxp*(gamma1*gamma1))+3.0*lam111*sigz/(msat)*(myp*gamma2+mzp*gamma3)*gamma1;
<a name="l00345"></a>00345     elasHkYp =  3.0/2.0*lam100*sigz/(msat)*(2.0*myp*(gamma2*gamma2))+3.0*lam111*sigz/(msat)*(mzp*gamma3+mxp*gamma1)*gamma2;
<a name="l00346"></a>00346     elasHkZp =  3.0/2.0*lam100*sigz/(msat)*(2.0*mzp*(gamma3*gamma3))+3.0*lam111*sigz/(msat)*(mxp*gamma1+myp*gamma2)*gamma3;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348     gamma1=b21;
<a name="l00349"></a>00349     gamma2=b22;
<a name="l00350"></a>00350     gamma3=b23;
<a name="l00351"></a>00351     elasHkXp += 3.0/2.0*lam100*sigy/(msat)*(2.0*mxp*(gamma1*gamma1))+3.0*lam111*sigy/(msat)*(myp*gamma2+mzp*gamma3)*gamma1;
<a name="l00352"></a>00352     elasHkYp += 3.0/2.0*lam100*sigy/(msat)*(2.0*myp*(gamma2*gamma2))+3.0*lam111*sigy/(msat)*(mzp*gamma3+mxp*gamma1)*gamma2;
<a name="l00353"></a>00353     elasHkZp += 3.0/2.0*lam100*sigy/(msat)*(2.0*mzp*(gamma3*gamma3))+3.0*lam111*sigy/(msat)*(mxp*gamma1+myp*gamma2)*gamma3;
<a name="l00354"></a>00354 
<a name="l00355"></a>00355     gamma1=b11;
<a name="l00356"></a>00356     gamma2=b12;
<a name="l00357"></a>00357     gamma3=b13;
<a name="l00358"></a>00358     elasHkXp += 3.0/2.0*lam100*sigx/(msat)*(2.0*mxp*(gamma1*gamma1))+3.0*lam111*sigx/(msat)*(myp*gamma2+mzp*gamma3)*gamma1;
<a name="l00359"></a>00359     elasHkYp += 3.0/2.0*lam100*sigx/(msat)*(2.0*myp*(gamma2*gamma2))+3.0*lam111*sigx/(msat)*(mzp*gamma3+mxp*gamma1)*gamma2;
<a name="l00360"></a>00360     elasHkZp += 3.0/2.0*lam100*sigx/(msat)*(2.0*mzp*(gamma3*gamma3))+3.0*lam111*sigx/(msat)*(mxp*gamma1+myp*gamma2)*gamma3;
<a name="l00361"></a>00361 
<a name="l00362"></a>00362     <span class="comment">/* convert into global coordinate system */</span>
<a name="l00363"></a>00363     PetscReal elasHkX,elasHkY,elasHkZ;
<a name="l00364"></a>00364     elasHkX=a11*elasHkXp+a12*elasHkYp+a13*elasHkZp;
<a name="l00365"></a>00365     elasHkY=a21*elasHkXp+a22*elasHkYp+a23*elasHkZp;
<a name="l00366"></a>00366     elasHkZ=a31*elasHkXp+a32*elasHkYp+a33*elasHkZp;
<a name="l00367"></a>00367 
<a name="l00368"></a>00368     <span class="comment">/* assemble cubic H components */</span>
<a name="l00369"></a>00369     ta_Helastic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0] = elasHkX/gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>*<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>;
<a name="l00370"></a>00370     ta_Helastic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1] = elasHkY/gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>*<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>;
<a name="l00371"></a>00371     ta_Helastic[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2] = elasHkZ/gdata-&gt;<a class="code" href="structGridData.html#adef301a549db3735cb025a5088ee0db6">hscale</a>*<a class="code" href="griddata_8h.html#a0fa11f33bdb89b468b60f19395381cc4">MU0</a>;
<a name="l00372"></a>00372   }
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);CHKERRQ(ierr);
<a name="l00375"></a>00375   ierr = VecRestoreArray(VHelastic,&amp;ta_Helastic);CHKERRQ(ierr);
<a name="l00376"></a>00376 
<a name="l00377"></a>00377   ierr = VecAXPY(VHtotsum,1.0,VHelastic);CHKERRQ(ierr);
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 <span class="comment">/* DEBUG: verify results</span>
<a name="l00380"></a>00380 <span class="comment">  PetscPrintf(PETSC_COMM_WORLD,</span>
<a name="l00381"></a>00381 <span class="comment">    &quot;deb01: time : %g and elasticfields are.: %lf,%lf ,%lf \n&quot;,</span>
<a name="l00382"></a>00382 <span class="comment">    gdata-&gt;time*gdata-&gt;tscale*1e9,elasHkX,elasHkY,elasHkZ</span>
<a name="l00383"></a>00383 <span class="comment">  );</span>
<a name="l00384"></a>00384 <span class="comment">  ierr = VecView(VHelastic,PETSC_VIEWER_STDOUT_WORLD);CHKERRQ(ierr);</span>
<a name="l00385"></a>00385 <span class="comment">*/</span>
<a name="l00386"></a>00386 
<a name="l00387"></a>00387   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00388"></a>00388 }
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00391"></a><a class="code" href="helastic_8c.html#a67380d67fc85c798265c8a83d73f5388">00391</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#a67380d67fc85c798265c8a83d73f5388">Helastic_Energy</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VMom,PetscReal *energy)
<a name="l00392"></a>00392 {
<a name="l00393"></a>00393   PetscReal e;
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="keywordflow">if</span> (!fieldon) {
<a name="l00398"></a>00398     *energy=0.0;
<a name="l00399"></a>00399     <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(0);
<a name="l00400"></a>00400   }
<a name="l00401"></a>00401 
<a name="l00402"></a>00402   ierr = VecDot(VMom,VHelastic,&amp;e);CHKERRQ(ierr);
<a name="l00403"></a>00403   e *= -1.0;
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   *energy=e;
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00408"></a>00408 }
<a name="l00409"></a>00409 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

